/* I2C-Bus DA-Converter SDA -> P1.0, SCL -> P1.1
 * Sinus aus 90 Werten ausgeben*/

#include <XMC1100-Lib.h>			// Hilfsfunktionen für XMC1100

/* Funktionen fuer I2C-Busschnittstelle (Master-Mode)
#define SDA  0       // Bit P1.0
#define SCL  1       // Bit P1.1
#define ACK  0
#define NACK 1
extern void    i2c_init    ( void );
extern void    i2c_start   ( void );
extern void    i2c_stop    ( void );
extern uint8_t i2c_write   ( uint8_t value);     // Rückgabewert Ack/Nack
extern uint8_t i2c_read    ( uint8_t ack );      // Rückgabewert value	*/

uint8_t z=0;							// Zählvariable
uint8_t sinus []= {
		128,136,145,154,163,171,180,188,195,203,210,216,223,228,234,
		238,243,246,249,252,254,255,255,255,255,254,252,249,246,243,
		238,234,228,223,216,210,203,195,188,180,171,163,154,145,136,
		128,119,110,101,92,84,75,67,60,52,45,39,32,27,21,
		17,12,9,6,3,1,0,0,0,0,1,3,6,9,12,
		17,21,27,32,39,45,52,60,67,75,84,92,101,110,119};

int main(void)							// Hauptprogramm
{
  i2c_init();							// I2C initialisieren
  bit_init(P2,2,INP);
  while(1U)								// Endlosschleife
  {
	  i2c_start();						// Startbedingung
	  i2c_write(0x96);					// Adresse, Master schreibt R/W=0
	  i2c_write(0x40);					// Controlbyte DAC-Ausgang freigeben
	  while (bit_read(P2,2)==1)			// ausgeben bis Taste gedrückt
	  {
		  i2c_write(sinus[z]);			// Wert ausgeben
		  if (z < 89) z++;  else z = 0;	// Tabelle abarbeiten
	  }// while (bit-read)
	  i2c_stop();						// Stoppbedingung
  }//while
}//main


